// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Ibconnectionbroker.pas' rev: 10.00

#ifndef IbconnectionbrokerHPP
#define IbconnectionbrokerHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Db.hpp>	// Pascal unit
#include <Ibdatabase.hpp>	// Pascal unit
#include <Ibheader.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Ibconnectionbroker
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TIBConnectionBrokerLogEvent)(System::TObject* Sender, AnsiString LogMessage);

class DELPHICLASS TIBPooledConnection;
class PASCALIMPLEMENTATION TIBPooledConnection : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	int FConnStatus;
	System::TDateTime FConnLockTime;
	System::TDateTime FConnCreateDate;
	Ibdatabase::TIBDatabase* FDatabase;
	
public:
	__fastcall virtual TIBPooledConnection(Classes::TComponent* AOwner);
	__property Ibdatabase::TIBDatabase* Database = {read=FDatabase};
	__property int ConnStatus = {read=FConnStatus, write=FConnStatus, nodefault};
	__property System::TDateTime ConnLockTime = {read=FConnLockTime, write=FConnLockTime};
	__property System::TDateTime ConnCreateDate = {read=FConnCreateDate, write=FConnCreateDate};
public:
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TIBPooledConnection(void) { }
	#pragma option pop
	
};


typedef DynamicArray<TIBPooledConnection* >  IBConnectionBroker__3;

class DELPHICLASS TIBConnectionBroker;
class PASCALIMPLEMENTATION TIBConnectionBroker : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	DynamicArray<TIBPooledConnection* >  FConnPool;
	AnsiString FDatabaseName;
	int FCurrConnections;
	int FConnLast;
	int FMinConns;
	int FMaxConns;
	unsigned FIdleTimer;
	Classes::TStrings* FDBParams;
	unsigned FDelay;
	TIBConnectionBrokerLogEvent FOnLog;
	void __fastcall SetDBParams(const Classes::TStrings* Value);
	void __fastcall SetMaxConns(const int Value);
	void __fastcall SetMinConns(const int Value);
	int __fastcall GetAllocated(void);
	int __fastcall GetAvailable(void);
	
protected:
	void __fastcall CreateConn(int i);
	void __fastcall DoLog(AnsiString msg);
	virtual void __fastcall Loaded(void);
	
public:
	_RTL_CRITICAL_SECTION CS1;
	Ibdatabase::TIBDatabase* __fastcall GetConnection(void);
	__fastcall virtual TIBConnectionBroker(Classes::TComponent* AOwner);
	__fastcall virtual ~TIBConnectionBroker(void);
	void __fastcall Init(void);
	void __fastcall ReleaseConnection(Ibdatabase::TIBDatabase* db);
	__property int AllocatedConnections = {read=GetAllocated, nodefault};
	__property int AvailableConnections = {read=GetAvailable, nodefault};
	
__published:
	__property AnsiString DatabaseName = {read=FDatabaseName, write=FDatabaseName};
	__property Classes::TStrings* Params = {read=FDBParams, write=SetDBParams};
	__property int MinConnections = {read=FMinConns, write=SetMinConns, default=10};
	__property int MaxConnections = {read=FMaxConns, write=SetMaxConns, default=20};
	__property unsigned TransactionIdleTimer = {read=FIdleTimer, write=FIdleTimer, nodefault};
	__property unsigned ExhaustedDelay = {read=FDelay, write=FDelay, default=500};
	__property TIBConnectionBrokerLogEvent OnLog = {read=FOnLog, write=FOnLog};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Ibconnectionbroker */
using namespace Ibconnectionbroker;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Ibconnectionbroker
