// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Iwdatamodulepool.pas' rev: 10.00

#ifndef IwdatamodulepoolHPP
#define IwdatamodulepoolHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Syncobjs.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Iwdatamodulepool
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TObjectEvent)(System::TObject* Sender, System::TObject* &AObject);

class DELPHICLASS TObjectPool;
class PASCALIMPLEMENTATION TObjectPool : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Syncobjs::TCriticalSection* CS;
	Classes::TList* ObjList;
	Classes::TBits* ObjInUse;
	bool FActive;
	bool FAutoGrow;
	int FGrowToSize;
	int FPoolSize;
	TObjectEvent FOnCreateObject;
	TObjectEvent FOnDestroyObject;
	int FUsageCount;
	bool FRaiseExceptions;
	
public:
	__fastcall virtual TObjectPool(void);
	__fastcall virtual ~TObjectPool(void);
	virtual void __fastcall Start(bool RaiseExceptions = false);
	virtual void __fastcall Stop(void);
	virtual System::TObject* __fastcall Acquire(void);
	virtual void __fastcall Release(System::TObject* item);
	__property bool Active = {read=FActive, nodefault};
	__property bool RaiseExceptions = {read=FRaiseExceptions, write=FRaiseExceptions, nodefault};
	__property int UsageCount = {read=FUsageCount, nodefault};
	__property int PoolSize = {read=FPoolSize, write=FPoolSize, nodefault};
	__property bool AutoGrow = {read=FAutoGrow, write=FAutoGrow, nodefault};
	__property int GrowToSize = {read=FGrowToSize, write=FGrowToSize, nodefault};
	__property TObjectEvent OnCreateObject = {read=FOnCreateObject, write=FOnCreateObject};
	__property TObjectEvent OnDestroyObject = {read=FOnDestroyObject, write=FOnDestroyObject};
};


typedef void __fastcall (__closure *TIWDataModuleEvent)(Classes::TDataModule* &ADataModule);

class DELPHICLASS TIWDataModulePool;
class PASCALIMPLEMENTATION TIWDataModulePool : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FSetToActive;
	TObjectPool* FPool;
	TIWDataModuleEvent FOnCreateDataModule;
	TIWDataModuleEvent FOnFreeDataModule;
	void __fastcall SetActive(const bool Value);
	void __fastcall SetPoolCount(const int Value);
	AnsiString __fastcall getVersion();
	void __fastcall SetVersion(const AnsiString Value);
	int __fastcall GetPoolCount(void);
	bool __fastcall GetActive(void);
	
protected:
	void __fastcall ErrorIfActive(void);
	void __fastcall ErrorIfNotActive(void);
	void __fastcall _OnCreateObject(System::TObject* Sender, System::TObject* &AObject);
	void __fastcall _OnDestroyObject(System::TObject* Sender, System::TObject* &AObject);
	virtual void __fastcall Loaded(void);
	
public:
	__fastcall virtual TIWDataModulePool(Classes::TComponent* AOwner);
	__fastcall virtual ~TIWDataModulePool(void);
	Classes::TDataModule* __fastcall Lock(void);
	void __fastcall Unlock(Classes::TDataModule* &ADataModule);
	int __fastcall CurrentThreadsInUse(void);
	
__published:
	__property TIWDataModuleEvent OnCreateDataModule = {read=FOnCreateDataModule, write=FOnCreateDataModule};
	__property TIWDataModuleEvent OnFreeDataModule = {read=FOnFreeDataModule, write=FOnFreeDataModule};
	__property int PoolCount = {read=GetPoolCount, write=SetPoolCount, nodefault};
	__property bool Active = {read=GetActive, write=SetActive, nodefault};
	__property AnsiString Version = {read=getVersion, write=SetVersion};
};


//-- var, const, procedure ---------------------------------------------------
#define COMPONENT_VERSION "2.0.0"
extern PACKAGE AnsiString __fastcall MakeUniqueDBName(AnsiString Prefix = "");

}	/* namespace Iwdatamodulepool */
using namespace Iwdatamodulepool;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Iwdatamodulepool
