// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Inlpr.pas' rev: 10.00

#ifndef InlprHPP
#define InlprHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Inassignednumbers.hpp>	// Pascal unit
#include <Inglobal.hpp>	// Pascal unit
#include <Inexception.hpp>	// Pascal unit
#include <Instreamvcl.hpp>	// Pascal unit
#include <Intcpclient.hpp>	// Pascal unit
#include <Incomponent.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Intcpconnection.hpp>	// Pascal unit
#include <Inbasecomponent.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Inlpr
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TInLPRFileFormat { ffCIF, ffDVI, ffFormattedText, ffPlot, ffControlCharText, ffDitroff, ffPostScript, ffPR, ffFORTRAM, ffTroff, ffSunRaster };
#pragma option pop

class DELPHICLASS TInLPRControlFile;
class PASCALIMPLEMENTATION TInLPRControlFile : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
protected:
	AnsiString FBannerClass;
	AnsiString FHostName;
	int FIndentCount;
	AnsiString FJobName;
	bool FBannerPage;
	AnsiString FUserName;
	int FOutputWidth;
	TInLPRFileFormat FFileFormat;
	AnsiString FTroffRomanFont;
	AnsiString FTroffItalicFont;
	AnsiString FTroffBoldFont;
	AnsiString FTroffSpecialFont;
	bool FMailWhenPrinted;
	
public:
	__fastcall TInLPRControlFile(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property AnsiString HostName = {read=FHostName, write=FHostName};
	
__published:
	__property AnsiString BannerClass = {read=FBannerClass, write=FBannerClass};
	__property int IndentCount = {read=FIndentCount, write=FIndentCount, default=0};
	__property AnsiString JobName = {read=FJobName, write=FJobName};
	__property bool BannerPage = {read=FBannerPage, write=FBannerPage, default=0};
	__property AnsiString UserName = {read=FUserName, write=FUserName};
	__property int OutputWidth = {read=FOutputWidth, write=FOutputWidth, default=0};
	__property TInLPRFileFormat FileFormat = {read=FFileFormat, write=FFileFormat, default=4};
	__property AnsiString TroffRomanFont = {read=FTroffRomanFont, write=FTroffRomanFont};
	__property AnsiString TroffItalicFont = {read=FTroffItalicFont, write=FTroffItalicFont};
	__property AnsiString TroffBoldFont = {read=FTroffBoldFont, write=FTroffBoldFont};
	__property AnsiString TroffSpecialFont = {read=FTroffSpecialFont, write=FTroffSpecialFont};
	__property bool MailWhenPrinted = {read=FMailWhenPrinted, write=FMailWhenPrinted, default=0};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TInLPRControlFile(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TInLPRStatus { psPrinting, psJobCompleted, psError, psGettingQueueState, psGotQueueState, psDeletingJobs, psJobsDeleted, psPrintingWaitingJobs, psPrintedWaitingJobs };
#pragma option pop

typedef void __fastcall (__closure *TInLPRStatusEvent)(System::TObject* ASender, const TInLPRStatus AStatus, const AnsiString AStatusText);

class DELPHICLASS TInLPR;
class PASCALIMPLEMENTATION TInLPR : public Intcpclient::TInTCPClientCustom 
{
	typedef Intcpclient::TInTCPClientCustom inherited;
	
protected:
	TInLPRStatusEvent FOnLPRStatus;
	AnsiString FQueue;
	int FJobId;
	TInLPRControlFile* FControlFile;
	void __fastcall DoOnLPRStatus(const TInLPRStatus AStatus, const AnsiString AStatusText);
	void __fastcall SeTInLPRControlFile(const TInLPRControlFile* Value);
	void __fastcall CheckReply(void);
	AnsiString __fastcall GetJobId();
	void __fastcall SetJobId(AnsiString JobId);
	void __fastcall InternalPrint(Instreamvcl::TInStreamVCL* Data);
	AnsiString __fastcall GetControlData();
	virtual void __fastcall InitComponent(void);
	
public:
	__fastcall virtual ~TInLPR(void);
	void __fastcall Print(AnsiString AText)/* overload */;
	void __fastcall Print(const Inglobal::TBytes ABuffer)/* overload */;
	void __fastcall PrintFile(AnsiString AFileName);
	AnsiString __fastcall GetQueueState(const bool AShortFormat = false, const AnsiString AList = "");
	void __fastcall PrintWaitingJobs(void);
	void __fastcall RemoveJobList(AnsiString AList, const bool AAsRoot = false);
	__property AnsiString JobId = {read=GetJobId, write=SetJobId};
	
__published:
	__property AnsiString Queue = {read=FQueue, write=FQueue};
	__property TInLPRControlFile* ControlFile = {read=FControlFile, write=SeTInLPRControlFile};
	__property TInLPRStatusEvent OnLPRStatus = {read=FOnLPRStatus, write=FOnLPRStatus};
public:
	#pragma option push -w-inl
	/* TInBaseComponent.Create */ inline __fastcall TInLPR(Classes::TComponent* AOwner)/* overload */ : Intcpclient::TInTCPClientCustom(AOwner) { }
	#pragma option pop
	
};


class DELPHICLASS EInLPRErrorException;
class PASCALIMPLEMENTATION EInLPRErrorException : public Inexception::EInException 
{
	typedef Inexception::EInException inherited;
	
public:
	#pragma option push -w-inl
	/* EInExceptionBase.Create */ inline __fastcall virtual EInLPRErrorException(AnsiString AMsg)/* overload */ : Inexception::EInException(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EInLPRErrorException(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Inexception::EInException(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EInLPRErrorException(int Ident)/* overload */ : Inexception::EInException(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EInLPRErrorException(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Inexception::EInException(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EInLPRErrorException(const AnsiString Msg, int AHelpContext) : Inexception::EInException(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EInLPRErrorException(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Inexception::EInException(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EInLPRErrorException(int Ident, int AHelpContext)/* overload */ : Inexception::EInException(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EInLPRErrorException(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Inexception::EInException(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EInLPRErrorException(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
#define DEF_FILEFORMAT (TInLPRFileFormat)(4)
static const Shortint DEF_INDENTCOUNT = 0x0;
static const bool DEF_BANNERPAGE = false;
static const Shortint DEF_OUTPUTWIDTH = 0x0;
static const bool DEF_MAILWHENPRINTED = false;

}	/* namespace Inlpr */
using namespace Inlpr;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Inlpr
